﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using BookStoreFramework;
using System.Linq;

namespace UnitTestProject
{
    [TestClass]
    public class UnitTest1
    {
        BookStoreContext _context = new BookStoreContext();

        [TestMethod]
        public void InsertTest()
        {
            MainWindow wnd = new MainWindow();
            string name, priceStr, author, category;
            int expectedCountBook, resultCountBook;

            // 1.1
            name = "Книга Илая";
            author = "Илай";
            priceStr = "1000";
            category = "Литература для слепых";

            expectedCountBook = _context.Books.Where(b => b.Name == name && b.Price == 1000 && b.Author == author && b.Category == category).Count() + 1;

            Assert.IsTrue(wnd.InsertBook(name, priceStr, author, category));

            resultCountBook = _context.Books.Where(b => b.Name == name && b.Price == 1000 && b.Author == author && b.Category == category).Count();
            Assert.AreEqual(expectedCountBook, resultCountBook);

            Books book = _context.Books.Where(b => b.Name == name && b.Price == 1000 && b.Author == author && b.Category == category).FirstOrDefault();
            _context.Books.Remove(book);
            _context.SaveChanges();

            // 1.2
            name = "Новая книга";
            author = "Новый автор";
            priceStr = "100";
            category = "Литература для новых";

            expectedCountBook = _context.Books.Where(b => b.Name == name && b.Price == 100 && b.Author == author && b.Category == category).Count() + 1;

            Assert.IsTrue(wnd.InsertBook(name, priceStr, author, category));

            resultCountBook = _context.Books.Where(b => b.Name == name && b.Price == 100 && b.Author == author && b.Category == category).Count();
            Assert.AreEqual(expectedCountBook, resultCountBook);

            book = _context.Books.Where(b => b.Name == name && b.Price == 100 && b.Author == author && b.Category == category).FirstOrDefault();
            _context.Books.Remove(book);
            _context.SaveChanges();

            // 2
            name = "Книга Илая";
            author = "Илай";
            priceStr = "lolkek";
            category = "Литература для слепых";

            expectedCountBook = _context.Books.Count();

            Assert.IsFalse(wnd.InsertBook(name, priceStr, author, category));

            resultCountBook = _context.Books.Count();
            Assert.AreEqual(expectedCountBook, resultCountBook);

            // 3
            name = "";
            author = "";
            priceStr = "1000";
            category = "Литература для слепых";

            expectedCountBook = _context.Books.Count();

            Assert.IsFalse(wnd.InsertBook(name, priceStr, author, category));

            resultCountBook = _context.Books.Count();
            Assert.AreEqual(expectedCountBook, resultCountBook);

            // 4
            name = "Книга Илая";
            author = "Илай";
            priceStr = "1000";
            category = "";

            expectedCountBook = _context.Books.Count();

            Assert.IsFalse(wnd.InsertBook(name, priceStr, author, category));

            resultCountBook = _context.Books.Count();
            Assert.AreEqual(expectedCountBook, resultCountBook);

            // 5
            name = "";
            author = "";
            priceStr = "";
            category = "";

            expectedCountBook = _context.Books.Count();

            Assert.IsFalse(wnd.InsertBook(name, priceStr, author, category));

            resultCountBook = _context.Books.Count();
            Assert.AreEqual(expectedCountBook, resultCountBook);
        }
    }
}
